' This is a empty shell to make the download possible.
' You must not compile this under no circumstances.
' It is only used for as loading shel and to discribe you how to use it.

  See Test Procedure Bellow !!!!!!!!


' -----[ Program Description ]--------------------------------------------------
'
' This program implements the ModBus RTU protocol in an universal I/O device
' It uses a special designed HW or STK200 development kit for testing purpouse.
' It's a polled slave with 16 in and 16 outputs.
'
' -----[ Disclaimer ]-----------------------------------------------------------
'
' This example is offered on an "AS IS" basis, no warranty expressed or implied.
' The programers disclaim liability of any damages associated with the use of
' the hardware or software described herein.
' You use it on your own risk. We are not able to provide any free support.
'
' Copyright (c) 2003 Mike Eitel all rights reserved
'
' -----[ Revision History ]-----------------------------------------------------
'
' 030410 - Version AVRMODDIO16        Ver 1.50 slave mclib 2313 ERAM  Mike Eitel

' *****[ conditional compiler flags ]*******************************************

Const Stk200 = 1                             ' When 1 then STK200 else DTR103

' *****[ conditional TEST flag ]************************************************

$regfile = "2313def.dat"

' Define serial communication parameters
$baud = 9600                                 ' ModBus speed
$crystal = 4000000                           ' Frequency of unit
' -----[ Aliases ]--------------------------------------------------------------


' -----[ Constants ]------------------------------------------------------------

'                            Telegramms solved
'         This device is capable of max 4 bytes data transfer mode 03 & 16 !!!
'
' Request Read    Holding Register(03)  SS 03 SH SL PH PL CL CH
' Answer  Read 16 Holding Register(03)  SS 03 BC 1H 1L CL CH
' Answer  Read 32 Holding Register(03)  SS 03 BC 1H 1L 2H 2L CL CH
'                                                       
'                                   DB( 1  2  3  4  5  6  7  8  9 )
'
' Request Preset Single Register(06)    SS 06 RH RL 1H 1L CL CH
' Answer  Preset Single Register(06)    SS 06 RH RL 1H 1L CL CH
'                                                     
'                                   DB( 1  2  3  4  5  6  7  8 )
'
' Request Preset Multiple Register(16)  SS 10 SH SL PH PL BC 1H 1L 2H 2L CL CH
' Answer  Preset Multiple Register(16)  SS 10 SH SL PH PL CL CH
'                                                               
'                                   DB( 1  2  3  4  5  6  7  8  9  10 11 12 13 )
'
'                                            ' SS = Slave Address
'                                            ' 03 = Command 03
'                                            ' SH = Starting Address High
'                                            ' SL= Starting Address Low
'                                            ' PH = Nr. of Points High
'                                            ' PL = Points Nr.(16 bits) Low
'                                            ' BC = Byte Count
'                                            ' 1H = Data 1 High
'                                            ' 1L = Data 1 Low
'                                            ' 2H = Data 2 High
'                                            ' 2L = Data 2 Low
'                                            ' CL = CRC Low
'                                            ' CH = CRC High

' -----[ Initialization ]---------------------------------------------
'
' Define port parameters
' Port B Is Used as output to LED of STK200

'  Port D  is used for communication and for latch controll
'  Ddrd.0                          ' RXD
'  Ddrd.1                          ' TXD

'  Ddrd.2 , 3, 4, 5 are usable switches of the STK200

'  Ddrd.6                          ' Enable for RS422 send pin
'  Ddrd.7                          ' NC for 2313


  Datas(adressparamter) = Myaddress          ' Set new Slave address
  Datas(parameters) = Myparameter            ' Set new Slave parameters

#if Stk200                                   ' ***** TEST MODE ***
  Datas(adressparamter) = 2                  ' Set test address
  Datas(parameters) = 4                      ' Set test parameters
#endif                                       ' ***** TEST MODE ***


'------[ Program ]----------------------------------------------------
  ' Routine for Inputs
  Datas(1) =                                 ' Read allowed swiches

  ' Routine for counting input changes
  Datas(7) = Datas(1) And Datas(parameters)  ' Check only

  ' Routine for Outputs
  ' If datas(5) is requesting high input pin, force output high. When input
  ' reaches high level forcing is surpressed.
  ' Generally output is OR overwriten high by normal output setting datas(3)
  Portb = Not [(datas(5) And Not Datas(1) ) Or Datas(3) ]

' And how to you make a test?
' 1. Place 2313 into STK200 and switch on
' 2. First you use the load to AVR without compiling
' 3. Choose your modbus master source and send to this slave with address 02

' In this description I talk from bytes, cause depending from used application
' U will use registers starting with register 0001. Sometimes the start with
' 10000 or higher. Please find that yourself, by monitoring the telegram.

' Inputs
' Test input switches by reading from bytes 00 00. Pressing the middle 4 switches
' will show a changed telegram status.

' The so called parameter is preset to monitor the activities of switch PD2.
' Each movement on that switch will increase value of bytes 00 06

' When you read from byte 00 0E you will see an incremented word counter.


' Outputs
' Test normal output functionality by sending to address 00 02. You can control
' result by LED status.

' Test fast output position control reaction by using bytes 00 04. As soon as
' you set a bit you will see LED going on, ( I propose PB4 ) and if you press
' according input ( PD4 ) the LED will switch off.

' Changing parameters
' If you write to byte 00 09 you can change slave address. And if you write to
' byte 00 08 you can change the surviewed switches. These changements are per-
' manetely stored in EERAM but are overwriten when device is powered up.

' This sample will stop working after ca. 3 minutes. You have to do reset AVR !!

' Have fun M. Eitel






